wxWidgets: wxImageFileProperty Class Reference

| Version: 3.1.5

Loading...
Searching...
No Matches
Public Member Functions | Protected Attributes | List of all members
wxImageFileProperty Class Reference

`#include </cygdrive/c/Users/Hamis/Cygwin-packaging/wxWidgets3.1/wxWidgets3.1-3.1.5-4.x86_64/src/wxWidgets-3.1.5/interface/wx/propgrid/advprops.h>`

Inheritance diagram for wxImageFileProperty:
[legend]

## Detailed Description

Property representing image file(name).

Supported special attributes:

- wxPG_DIALOG_TITLE: Sets a specific title for the file dialog (since 3.1.3).
- wxPG_FILE_DIALOG_STYLE: Sets a specific wxFileDialog style for the file dialog.
- wxPG_FILE_WILDCARD: Sets wildcard (see wxFileDialog for format details), "All files..." is default.
- wxPG_FILE_SHOW_FULL_PATH: Default true. When false, only the file name is shown (i.e. drive and directory are hidden).
- wxPG_FILE_SHOW_RELATIVE_PATH: If set, then the filename is shown relative to the given path string.
- wxPG_FILE_INITIAL_PATH: Sets the initial path of where to look for files.

## Public Member Functions
| wxImageFileProperty (const wxString &label=wxPG_LABEL, const wxString &name=wxPG_LABEL, const wxString &value=wxEmptyString)
virtual | ~wxImageFileProperty ()
virtual void | OnSetValue ()
| This virtual function is called after m_value has been set.
virtual wxSize | OnMeasureImage (int item) const
| Returns size of the custom painted image in front of property.
virtual void | OnCustomPaint (wxDC &dc, const wxRect &rect, wxPGPaintData &paintdata)
| Override to paint an image in front of the property value text or drop-down list item (but only if wxPGProperty::OnMeasureImage is overridden as well).
Public Member Functions inherited from wxFileProperty
| wxFileProperty (const wxString &label=wxPG_LABEL, const wxString &name=wxPG_LABEL, const wxString &value=wxEmptyString)
virtual | ~wxFileProperty ()
virtual wxString | ValueToString (wxVariant &value, int argFlags=0) const
| Converts property value into a text representation.
virtual bool | StringToValue (wxVariant &variant, const wxString &text, int argFlags=0) const
| Converts text into wxVariant value appropriate for this property.
virtual bool | DoSetAttribute (const wxString &name, wxVariant &value)
| Reimplement this member function to add special handling for attributes of this property.
virtual wxValidator * | DoGetValidator () const
| Returns pointer to the wxValidator that should be used with the editor of this property (NULL for no validator).
wxFileName | GetFileName () const
| Returns filename to file represented by current value.
Public Member Functions inherited from wxEditorDialogProperty
virtual | ~wxEditorDialogProperty ()
virtual wxPGEditorDialogAdapter * | GetEditorDialog () const
| Returns instance of a new wxPGEditorDialogAdapter instance, which is used when user presses the (optional) button next to the editor control;.
Public Member Functions inherited from wxPGProperty
virtual | ~wxPGProperty ()
| Virtual destructor.
virtual wxVariant | DoGetValue () const
| Override this to return something else than m_value as the value.
virtual bool | ValidateValue (wxVariant &value, wxPGValidationInfo &validationInfo) const
| Implement this function in derived class to check the value.
virtual bool | IntToValue (wxVariant &variant, int number, int argFlags=0) const
| Converts integer (possibly a choice selection) into wxVariant value appropriate for this property.
bool | SetValueFromString (const wxString &text, int flags=wxPG_PROGRAMMATIC_VALUE)
| Converts string to a value, and if successful, calls SetValue() on it.
bool | SetValueFromInt (long value, int flags=0)
| Converts integer to a value, and if successful, calls SetValue() on it.
virtual bool | OnEvent (wxPropertyGrid *propgrid, wxWindow *wnd_primary, wxEvent &event)
| Events received by editor widgets are processed here.
virtual wxVariant | ChildChanged (wxVariant &thisValue, int childIndex, wxVariant &childValue) const
| Called after value of a child property has been altered.
virtual const wxPGEditor * | DoGetEditorClass () const
| Returns pointer to an instance of used editor.
virtual wxPGCellRenderer * | GetCellRenderer (int column) const
| Returns used wxPGCellRenderer instance for given property column (label=0, value=1).
virtual int | GetChoiceSelection () const
| Returns which choice is currently selected.
virtual void | RefreshChildren ()
| Refresh values of child properties.
virtual wxVariant | DoGetAttribute (const wxString &name) const
| Returns value of an attribute.
virtual void | OnValidationFailure (wxVariant &pendingValue)
| Called whenever validation has failed with given pending value.
int | AddChoice (const wxString &label, int value=wxPG_INVALID_VALUE)
| Append a new choice to property's list of choices.
void | AddChild (wxPGProperty *prop)
| Adds a private child property.
void | AddPrivateChild (wxPGProperty *prop)
| Adds a private child property.
void | AdaptListToValue (wxVariant &list, wxVariant *value) const
| Adapts list variant into proper value using consecutive ChildChanged() calls.
wxPGProperty * | AppendChild (wxPGProperty *childProperty)
| Use this member function to add independent (i.e.
bool | AreAllChildrenSpecified (wxVariant *pendingList=NULL) const
| Determines, recursively, if all children are not unspecified.
bool | AreChildrenComponents () const
| Returns true if children of this property are component values (for instance, points size, face name, and is_underlined are component values of a font).
void | ChangeFlag (wxPGPropertyFlags flag, bool set)
| Sets or clears given property flag.
void | DeleteChildren ()
| Deletes children of the property.
void | DeleteChoice (int index)
| Removes entry from property's wxPGChoices and editor control (if it is active).
void | Enable (bool enable=true)
| Enables or disables the property.
void | EnableCommonValue (bool enable=true)
| Call to enable or disable usage of common value (integer value that can be selected for properties instead of their normal values) for this property.
wxString | GenerateComposedValue () const
| Composes text from values of child properties.
const wxString & | GetLabel () const
| Returns property's label.
wxVariant | GetAttribute (const wxString &name) const
| Returns property attribute value, null variant if not found.
wxString | GetAttribute (const wxString &name, const wxString &defVal) const
| Returns named attribute, as string, if found.
long | GetAttributeAsLong (const wxString &name, long defVal) const
| Returns named attribute, as long, if found.
double | GetAttributeAsDouble (const wxString &name, double defVal) const
| Returns named attribute, as double, if found.
const wxPGAttributeStorage & | GetAttributes () const
| Returns map-like storage of property's attributes.
wxVariant | GetAttributesAsList () const
| Returns attributes as list wxVariant.
const wxPGEditor * | GetColumnEditor (int column) const
| Returns editor used for given column.
const wxString & | GetBaseName () const
| Returns property's base name (i.e.
const wxPGCell & | GetCell (unsigned int column) const
| Returns wxPGCell of given column.
wxPGCell & | GetCell (unsigned int column)
| Returns wxPGCell of given column, creating one if necessary.
wxPGCell & | GetOrCreateCell (unsigned int column)
| Returns wxPGCell of given column, creating one if necessary.
unsigned int | GetChildCount () const
| Returns number of child properties.
int | GetChildrenHeight (int lh, int iMax=-1) const
| Returns height of children, recursively, and by taking expanded/collapsed status into account.
const wxPGChoices & | GetChoices () const
| Returns read-only reference to property's list of choices.
void * | GetClientData () const
| Returns client data (void*) of a property.
wxClientData * | GetClientObject () const
| Gets managed client object of a property.
wxVariant | GetDefaultValue () const
| Returns property's default value.
int | GetCommonValue () const
| Returns common value selected for this property.
unsigned int | GetDepth () const
int | GetDisplayedCommonValueCount () const
| Return number of displayed common values for this property.
wxString | GetDisplayedString () const
| Returns property's displayed text.
const wxPGEditor * | GetEditorClass () const
| Returns wxPGEditor that will be used and created when property becomes selected.
wxString | GetHintText () const
| Returns property's hint text (shown in empty value cell).
wxPropertyGrid * | GetGrid () const
| Returns property grid where property lies.
wxPropertyGrid * | GetGridIfDisplayed () const
| Returns owner wxPropertyGrid, but only if one is currently on a page displaying this property.
const wxString & | GetHelpString () const
| Returns property's help or description text.
wxString | GetFlagsAsString (FlagType flagsMask) const
| Gets flags as a'|' delimited string.
unsigned int | GetIndexInParent () const
| Returns position in parent's array.
const wxPGProperty * | GetLastVisibleSubItem () const
| Returns last visible child property, recursively.
wxPGProperty * | GetMainParent () const
| Returns highest level non-category, non-root parent.
int | GetMaxLength () const
| Returns maximum allowed length of the text the user can enter in the property text editor.
wxString | GetName () const
| Returns property's name with all (non-category, non-root) parents.
wxPGProperty * | GetParent () const
| Return parent of property.
wxPGProperty * | GetPropertyByName (const wxString &name) const
| Returns (direct) child property with given name (or NULL if not found).
wxValidator * | GetValidator () const
| Gets assignable version of property's validator.
wxVariant | GetValue () const
| Returns property's value.
wxBitmap * | GetValueImage () const
| Returns bitmap that appears next to value text.
virtual wxString | GetValueAsString (int argFlags=0) const
| Returns text representation of property's value.
wxString | GetValueString (int argFlags=0) const
| Synonymous to GetValueAsString().
wxString | GetValueType () const
| Returns value type used by this property.
int | GetY () const
| Returns coordinate to the top y of the property.
int | GetImageOffset (int imageWidth) const
| Converts image width into full image offset, with margins.
wxPGProperty * | GetItemAtY (unsigned int y) const
| Returns property at given virtual y coordinate.
bool | HasFlag (wxPGPropertyFlags flag) const
| Returns true if property has given flag set.
bool | HasFlag (FlagType flag) const
| Returns true if property has given flag set.
bool | HasFlagsExact (FlagType flags) const
| Returns true if property has all given flags set.
bool | HasVisibleChildren () const
| Returns true if property has even one visible child.
bool | Hide (bool hide, int flags=wxPG_RECURSE)
| Hides or reveals the property.
int | Index (const wxPGProperty *p) const
| Returns index of given child property.
wxPGProperty * | InsertChild (int index, wxPGProperty *childProperty)
| Use this member function to add independent (i.e.
int | InsertChoice (const wxString &label, int index, int value=wxPG_INVALID_VALUE)
| Inserts a new choice to property's list of choices.
bool | IsCategory () const
| Returns true if this property is actually a wxPropertyCategory.
bool | IsEnabled () const
| Returns true if property is enabled.
bool | IsExpanded () const
| Returns true if property has visible children.
bool | IsRoot () const
| Returns true if this property is actually a wxRootProperty.
bool | IsSubProperty () const
| Returns true if this is a sub-property.
bool | IsSomeParent (wxPGProperty *candidateParent) const
| Returns true if candidateParent is some parent of this property.
bool | IsTextEditable () const
| Returns true if property has editable wxTextCtrl when selected.
bool | IsValueUnspecified () const
| Returns true if property's value is considered unspecified.
bool | IsVisible () const
| Returns true if all parents expanded.
wxPGProperty * | Item (unsigned int i) const
| Returns child property at index i.
wxPGProperty * | Last () const
| Returns last sub-property.
bool | RecreateEditor ()
| If property's editor is created this forces its recreation.
void | RefreshEditor ()
| If property's editor is active, then update it's value.
void | SetAttribute (const wxString &name, wxVariant value)
| Sets an attribute for this property.
void | SetAttributes (const wxPGAttributeStorage &attributes)
void | SetAutoUnspecified (bool enable=true)
| Set if user can change the property's value to unspecified by modifying the value of the editor control (usually by clearing it).
void | SetBackgroundColour (const wxColour &colour, int flags=wxPG_RECURSE)
| Sets property's background colour.
void | SetEditor (const wxPGEditor *editor)
| Sets editor for a property.
void | SetEditor (const wxString &editorName)
| Sets editor for a property, by editor name.
void | SetCell (int column, const wxPGCell &cell)
| Sets cell information for given column.
void | SetCommonValue (int commonValue)
| Sets common value selected for this property.
bool | SetChoices (wxPGChoices &choices)
| Sets new set of choices for the property.
void | SetClientData (void *clientData)
| Sets client data (void*) of a property.
void | SetClientObject (wxClientData *clientObject)
| Sets client object of a property.
void | SetChoiceSelection (int newValue)
| Sets selected choice and changes property value.
void | SetDefaultValue (wxVariant &value)
| Set default value of a property.
void | SetExpanded (bool expanded)
void | SetFlagsFromString (const wxString &str)
| Sets flags from a '|' delimited string.
void | SetFlagRecursively (wxPGPropertyFlags flag, bool set)
| Sets or clears given property flag, recursively.
void | SetHelpString (const wxString &helpString)
| Sets property's help string, which is shown, for example, in wxPropertyGridManager's description text box.
void | SetLabel (const wxString &label)
| Sets property's label.
bool | SetMaxLength (int maxLen)
| Set maximum length of the text the user can enter in the text editor.
void | SetModifiedStatus (bool modified)
| Sets property's "is it modified?" flag.
void | SetName (const wxString &newName)
| Sets new (base) name for property.
void | SetParentalType (int flag)
| Changes what sort of parent this property is for its children.
void | SetTextColour (const wxColour &colour, int flags=wxPG_RECURSE)
| Sets property's text colour.
void | SetDefaultColours (int flags=wxPG_RECURSE)
| Sets property's default text and background colours.
void | SetValidator (const wxValidator &validator)
| Sets wxValidator for a property.
void | SetValue (wxVariant value, wxVariant *pList=NULL, int flags=wxPG_SETVAL_REFRESH_EDITOR)
| Call this to set value of the property.
void | SetValueImage (wxBitmap &bmp)
| Set wxBitmap in front of the value.
void | SetValueInEvent (wxVariant value) const
| Call this function in OnEvent(), OnButtonClick() etc.
void | SetValueToUnspecified ()
| Sets property's value to unspecified (i.e.
void | SetWasModified (bool set=true)
| Call with false in OnSetValue() to cancel value changes after all (i.e.
wxPGProperty * | UpdateParentValues ()
| Updates composed values of parent non-category properties, recursively.
bool | UsesAutoUnspecified () const
| Returns true if containing grid uses wxPG_EX_AUTO_UNSPECIFIED_VALUES.
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data.
| wxObject (const wxObject &other)
| Copy ctor.
virtual | ~wxObject ()
| Destructor.
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar).
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object.
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class.
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj.
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone.
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer.
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data.
void | UnShare ()
| This is the same of AllocExclusive() but this method is public.
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined.
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined.

## Protected Attributes
wxBitmap * | m_pBitmap
wxImage * | m_pImage
Protected Attributes inherited from wxFileProperty
wxString | m_wildcard
wxString | m_basePath
wxString | m_initialPath
int | m_indFilter
Protected Attributes inherited from wxEditorDialogProperty
wxString | m_dlgTitle
long | m_dlgStyle
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data.

## Additional Inherited Members
Public Types inherited from wxPGProperty
typedef wxUint32 | FlagType
Static Public Member Functions inherited from wxFileProperty
static wxValidator * | GetClassValidator ()
Public Attributes inherited from wxPGProperty
void * | m_clientData
| This member is public so scripting language bindings wrapper code can access it freely.
Protected Member Functions inherited from wxFileProperty
virtual bool | DisplayEditorDialog (wxPropertyGrid *pg, wxVariant &value)
| Shows editor dialog.
Protected Member Functions inherited from wxEditorDialogProperty
| wxEditorDialogProperty (const wxString &label, const wxString &name)
| Constructor is protected because wxEditorDialogProperty is only the base class for other property classes.
Protected Member Functions inherited from wxPGProperty
| wxPGProperty ()
| Default constructor.
| wxPGProperty (const wxString &label, const wxString &name)
| Constructor.
void | AdaptiveSetCell (unsigned int firstCol, unsigned int lastCol, const wxPGCell &preparedCell, const wxPGCell &srcData, wxPGCellData *unmodCellData, FlagType ignoreWithFlags, bool recursively)
| Sets property cell in fashion that reduces number of exclusive copies of cell data.
void | ClearCells (FlagType ignoreWithFlags, bool recursively)
| Clear cells associated with property.
void | EnsureCells (unsigned int column)
| Makes sure m_cells has size of column+1 (or more).
wxPGProperty * | GetPropertyByNameWH (const wxString &name, unsigned int hintIndex) const
| Returns (direct) child property with given name (or NULL if not found), with hint index.
void | DoAddChild (wxPGProperty *prop, int index=-1, bool correct_mode=true)
| This is used by Insert etc.
void | Empty ()
| Deletes all child properties.
bool | IsChildSelected (bool recursive=false) const
| Returns true if child property is selected.
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object.
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it.
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data.

## Constructor & Destructor Documentation

## ◆ wxImageFileProperty()

wxImageFileProperty::wxImageFileProperty | ( | const wxString & | label = wxPG_LABEL,
|  | const wxString & | name = wxPG_LABEL,
|  | const wxString & | value = wxEmptyString )

## ◆ ~wxImageFileProperty()

virtual wxImageFileProperty::~wxImageFileProperty | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ OnCustomPaint()

virtual void wxImageFileProperty::OnCustomPaint | ( | wxDC & | dc,
|  | const wxRect & | rect,
|  | wxPGPaintData & | paintdata )
| virtual

Override to paint an image in front of the property value text or drop-down list item (but only if wxPGProperty::OnMeasureImage is overridden as well).

If property's OnMeasureImage() returns size that has height != 0 but less than row height ( < 0 has special meanings), wxPropertyGrid calls this method to draw a custom image in a limited area in front of the editor control or value text/graphics, and if control has drop-down list, then the image is drawn there as well (even in the case OnMeasureImage() returned higher height than row height).

NOTE: Following applies when OnMeasureImage() returns a "flexible" height ( using `wxPG_FLEXIBLE_SIZE(W,H)` macro), which implies variable height items: If (rect.x+rect.width) is < 0, then this is a measure item call, which means that dc is invalid and only thing that should be done is to set paintdata.m_drawnHeight to the height of the image of item at index paintdata.m_choiceItem. This call may be done even as often as once every drop-down popup show.

Parameters

  dc | wxDC to paint on.
  rect | Box reserved for custom graphics. Includes surrounding rectangle, if any. If x+width is < 0, then this is a measure item call (see above).
  paintdata | wxPGPaintData structure with much useful data about painted item. struct wxPGPaintData { // wxPropertyGrid. const wxPropertyGrid* m_parent; // Normally -1, otherwise index to drop-down list item that has to be drawn. int m_choiceItem; // Set to drawn width in OnCustomPaint (optional). int m_drawnWidth; // In a measure item call, set this to the height of item at m_choiceItem index int m_drawnHeight; }; wxPropertyGrid wxPropertyGrid is a specialized grid for editing properties - in other words name = value pairs. Definition propgrid.h:487 wxPGPaintData Contains information related to property's OnCustomPaint. Definition property.h:16

Remarks
  - You can actually exceed rect width, but if you do so then paintdata.m_drawnWidth must be set to the full width drawn in pixels.
  - Due to technical reasons, rect's height will be default even if custom height was reported during measure call.
  - Brush is guaranteed to be default background colour. It has been already used to clear the background of area being painted. It can be modified.
  - Pen is guaranteed to be 1-wide 'black' (or whatever is the proper colour) pen for drawing framing rectangle. It can be changed as well.

See also
  ValueToString()

Reimplemented from wxPGProperty.

## ◆ OnMeasureImage()

virtual wxSize wxImageFileProperty::OnMeasureImage | ( | int | item | ) | const
| virtual

Returns size of the custom painted image in front of property.

This method must be overridden to return non-default value if OnCustomPaint is to be called.

Parameters

  item | Normally -1, but can be an index to the property's list of items.

Remarks
  - Default behaviour is to return wxSize(0,0), which means no image.
  - Default image width or height is indicated with dimension -1.
  - You can also return wxPG_DEFAULT_IMAGE_SIZE which equals wxDefaultSize.

Reimplemented from wxPGProperty.

## ◆ OnSetValue()

virtual void wxImageFileProperty::OnSetValue | ( |  | ) |
| virtual

This virtual function is called after m_value has been set.

Remarks
  - If m_value was set to Null variant (i.e. unspecified value), OnSetValue() will not be called.
  - m_value may be of any variant type. Typically properties internally support only one variant type, and as such OnSetValue() provides a good opportunity to convert supported values into internal type.
  - Default implementation does nothing.

Reimplemented from wxFileProperty.

## Member Data Documentation

## ◆ m_pBitmap

wxBitmap* wxImageFileProperty::m_pBitmap
| protected

## ◆ m_pImage

wxImage* wxImageFileProperty::m_pImage
| protected